# Examples

- **[/Themis-Server](https://github.com/cossacklabs/themis/tree/master/docs/examples/Themis-server)** : examples for Secure Session and Secure Message, specifically tailored to talk to Themis Server (themis.cossacklabs.com), for all languages

- **[/c/ssession-test](https://github.com/cossacklabs/themis/tree/master/docs/examples/c/ssession_test)** : Secure Session example in C we wrote somewhere early in development to illustrate the core attitude.

- **[/swift/](https://github.com/cossacklabs/themis/tree/master/docs/examples/swift)** : Swift example project, code pieces illustrating how to use SecureMessage and SecureCell

- **[/objc/](https://github.com/cossacklabs/themis/tree/master/docs/examples/objc)** : Objective-C example project, code pieces illustrating how to use SecureMessage and SecureCell

- **[/php/](https://github.com/cossacklabs/themis/tree/master/docs/examples/php)** : PHP sample code 
  - [/php/scell_test.php](https://github.com/cossacklabs/themis/blob/master/docs/examples/php/scell_test.php) : PHP Secure Cell example
  - [/php/smessage_test.php](https://github.com/cossacklabs/themis/blob/master/docs/examples/php/smessage_test.php) : PHP Secure Message example
  - [/php/ssession_client.php](https://github.com/cossacklabs/themis/blob/master/docs/examples/php/ssession_client.php) : PHP  Secure Session client example
  - [/php/ssession_server.php](https://github.com/cossacklabs/themis/blob/master/docs/examples/php/ssession_server.php) : PHP  Secure Session server example

- **[/python/](https://github.com/cossacklabs/themis/tree/master/docs/examples/python)** : Python sample code
  - [/python/scell_test_postgres.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/scell_test_postgres.py) : Using Secure Cell in PostgreSQL in Python
  - [/python/scell_xml_format-preserving_encryption.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/scell_xml_format-preserving_encryption.py) : Using Secure Cell to do format preserving encryption within XML tree in Python
  - [/python/skeygen_test.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/skeygen_test.py) : Python key generation example
  - [/python/smessage_ssocket.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_ssocket.py) : Python Secure Message encryption selfmade-socket example - core object
  - [/python/smessage_test_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_test_client.py) : Python Secure Message encrypt mode selfmade-socket example - client
  - [/python/smessage_test_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_test_server.py) : Python Secure Message encrypt mode selfmade-socket example - server
  - [/python/smessage_ssocket_sv.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_ssocket_sv.py) : Python Secure Message sign/verify mode selfmade-socket example - core object 
  - [/python/smessage_sv_test_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_sv_test_client.py) : Python Secure Message sign/verify mode selfmade-socket example - client
  - [/python/smessage_sv_test_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_sv_test_server.py) : Python Secure Message sign/verify selfmade-socket example - server
  - [/python/smessage_test_tornado_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_test_tornado_client.py) : Python Secure Message Tornado framework-based example - client
  - [/python/smessage_test_tornado_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_test_tornado_server.py) : Python Secure Message Tornado framework-based example - Server
  - [/python/smessage_test_twisted.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/smessage_test_twisted.py) : Python Secure Message simple echo server in Twisted (as an example of protocol definition)
  - [/python/ssession_rabbitMQ_client_test.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_rabbitMQ_client_test.py) : Python Secure Session with RabbitMQ as a transport - client
  - [/python/ssession_rabbitMQ_server_test.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_rabbitMQ_server_test.py) : Python Secure Session with RabbitMQ as a transport - server
  - [/python/ssession_wrappers.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_wrappers.py) : Python Secure Session for non-event handled cases like plain sockets - wrapper
  - [/python/ssession_test_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_test_client.py) : Python Secure Session for non-event handled cases like plain sockets - client
  - [/python/ssession_test_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_test_server.py) : Python Secure Session for non-event handled cases like plain sockets - server
  - [/python/ssession_test_tornado_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_test_tornado_client.py) : Python Secure Session for Tornado - client
  - [/python/ssession_test_tornado_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_test_tornado_server.py) : Python Secure Session for Tornado - server
  - [/python/ssession_test_twisted.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/ssession_test_twisted.py) : Python Secure Session for Twisted - echo server
  - [/python/scomparator_test_client.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/scomparator_test_client.py) : Python Secure Comparator client (warning! experimental feature)
  - [/python/scomparator_test_server.py](https://github.com/cossacklabs/themis/blob/master/docs/examples/python/scomparator_test_server.py) : Python Secure Comparator server (warning! experimental feature)

- **[/ruby/](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/)** : Ruby Sample code
  - [/ruby/scell_test.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/scell_test.rb) : Ruby Secure Cell example
  - [/ruby/skeygen.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/skeygen.rb) : Key generation in Ruby example
  - [/ruby/smessage_test.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/smessage_test.rb) : Very simple local Secure Message example
  - [/ruby/ssession_test_eventmachine_client.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/ssession_test_eventmachine_client.rb) : Secure Session on Ruby EventMachine framework - client
  - [/ruby/ssession_test_eventmachine_server.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/ssession_test_eventmachine_server.rb) : Secure Session on Ruby EventMachine framework - server
  - [/ruby/scomparator_test_eventmachine_client.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/scomparator_test_eventmachine_client.rb) : Secure Comparator example client (warning! experimental feature!)
  - [/ruby/scomparator_test_eventmachine_server.rb](https://github.com/cossacklabs/themis/blob/master/docs/examples/ruby/scomparator_test_eventmachine_server.rb) : Secure Comparator example client (warning! experimental feature!)

- **[/c++/](https://github.com/cossacklabs/themis/tree/master/docs/examples/c%2B%2B)** : C++ sample code
  - [/c++/secure_cell_file_encrypter.cpp](https://github.com/cossacklabs/themis/blob/master/docs/examples/c%2B%2B/secure_cell_file_encrypter.cpp) : Secure Cell seal mode example (easily modifiable to other Secure Cell types)
  - [/c++/secure_message_client.cpp](https://github.com/cossacklabs/themis/blob/master/docs/examples/c%2B%2B/secure_message_client.cpp) : Secure Message client
  - [/c++/secure_message_client.cpp](https://github.com/cossacklabs/themis/blob/master/docs/examples/c%2B%2B/secure_message_server.cpp) : Secure Message server
  - [/c++/secure_session_client.cpp](https://github.com/cossacklabs/themis/blob/master/docs/examples/c%2B%2B/secure_session_client.cpp) : Secure Session client
  - [/c++/secure_session_server.cpp](https://github.com/cossacklabs/themis/blob/master/docs/examples/c%2B%2B/secure_session_server.cpp) : Secure Session server

- **[/js/]()** : NodeJS sample code
  - [/js/secure_cell.js](https://github.com/cossacklabs/themis/blob/master/docs/examples/js/secure_cell.js) : Secure Cell example
  - [/js/secure_keygen.js](https://github.com/cossacklabs/themis/blob/master/docs/examples/js/secure_keygen.js) : Key generation example
  - [/js/secure_message.js](https://github.com/cossacklabs/themis/blob/master/docs/examples/js/secure_message.js) : Secure Message example
  - [/js/secure_session_client.js](https://github.com/cossacklabs/themis/blob/master/docs/examples/js/secure_session_client.js) : Secure Session client example
  - [/js/secure_session_server.js](https://github.com/cossacklabs/themis/blob/master/docs/examples/js/secure_session_server.js) : Secure Session server example

### Tutorials, etc. 

You might also enjoy tutorials with real-world projects: 

- [Securing websocket chat tutorial](https://cossacklabs.com/building-secure-chat) | [code](https://github.com/cossacklabs/mobile-websocket-example)
- [Themis usability testing hackathon](https://cossacklabs.com/02-usability-testing.html) | [code](https://github.com/cossacklabs/themis-ux-testing) 
- [0fc anonymous web chat](https://github.com/cossacklabs/0fc), pythemis (Python) + webthemis (C++ + HTML/JS): [blog post](https://cossacklabs.com/building-endtoend-webchat.html)
- [sesto: secure storage](https://github.com/cossacklabs/sesto), pythemis (Python) + webthemis (C++ + HTML/JS): [blog post](https://cossacklabs.com/presenting-sesto.html)

### Tests

Actually, [real tests](https://github.com/cossacklabs/themis/tree/master/tests) used to build Themis are good examples themselves.
